;SMK VIDEO PLAYER CALLING CODE
;object:
;[obj]          = VTable
;[obj+4]        = n/a
;[obj+8]        = address of video name+path
;[obj+12]       = run only once boolean (bit 0 = true, bit 1= has been run)
;[obj+16]       = saved run only once boolean (for re-init)
;[obj+20]       = usual video name string start

struct CAT105
       lpVTable 		dd	?
       refCount 		dd	?
       lpVideoFilename		dd	?
       Flags			dd	?
       InitialFlags		dd	?
       lpVideoFilepart		dd	?
ends

;Note: I can't remember why I put the following line here (bear with me).
IID_IDirectDraw4	db	'{9C59509A-39BD-11D1-8C4A-00C04FD930C5}',0

align 16
;==========================================================
AT105MAIN:
;==========================================================
cmp BYTE [ecx+12],3
    jz NoVideo_105
cmp DWORD [ecx+8],0
    jz NoVideo_105

	or BYTE [ecx+12],2

push ebp
mov ebp,esp
push ebx
sub esp,250h	;(don't know exact needed buffer)
push edi
mov edi,ecx

	lea eax,[ebp-50h]		;required sub-object (placed in [ebp-24Ch])
					;emulated values required for no crash
	mov [eax+38h],DWORD 100 	;(anything above 4)
	mov [eax+3Ch],DWORD 0		;(MUST be NULL-> incremented to 4)
	mov [eax+40h],DWORD 1		;(anything but NULL)

	lea ecx,[ebp-250h]
	push eax
	call DWORD [VIDEO_OBJ_ALLOC_PROC] ;init 'video' or such object

	push DWORD [edi+8]		 ;address of video name+path
	lea ecx,[ebp-250h]
	call DWORD [VIDEO_PLAY_PROC]	;play video!

	lea ecx,[ebp-250h]
	call DWORD [VIDEO_RELEASE_PROC]

pop edi
pop ebx
mov esp,ebp
pop ebp
NoVideo_105:
ret

align 16
;==========================================================
AT105_REINIT:
;==========================================================
mov eax,[ecx+16]
mov [ecx+12],eax
mov eax,[esp+4]
ret 4

align 16
;====================================================================
_AT105Init:
;====================================================================
GETVALUE Sample,0		;get video "Sample" string first
sub esp,4
mov edi,esp
SETVALUE value_string,1
pop edi 			;edi=pointer to string (if valid)
test eax,eax
     jz NoNewActionType 	;leave if no valid string

mov ebx,edi
FINDSTRINGEND ebx
sub ebx,edi
    jz NoNewActionType		;0 length?
inc ebx 			;ebx=string length (w/null terminator)
mov [ebp-4],edi 		;string addr start

lea edx,[ebx+20]		;20 for object, the rest for string

ALLOCAT edx
lea eax,[AT105]
mov [edi],eax
    lea edx,[edi+20]
mov [edi+4],DWORD 0
mov [edi+8],edx
mov [edi+12],DWORD 0

MOVESTRING [edi+20],[ebp-4],ebx

GETVALUE LoopCount,1
SETVALUE value_bool,4

mov eax,[edi+12]
mov [edi+16],eax

	jmp ExitINAT