;============================================================
;MAIN NEWACTIONTYPE INITIALIZATION CODE
;============================================================
;->must return new object in esi if initsuccess

include '_INAT_PROCS_MACROS.inc'

;====================================================================
INAT:			;eax = AT number
;====================================================================
push ebp
mov ebp,esp
sub esp,16		;possible local values, not necessarily used
push ecx
push edx
push ebx
push esi
push edi
xor edx,edx
mov [ebp-16],edx
mov [ebp-12],edx
mov [ebp-8],edx
mov [ebp-4],edx

	sub eax,100
	cmp eax,NUM_NEWACTIONTYPES
	jnb NoNewActionType

	jmp DWORD [ATINATTable+4*eax]

NoNewActionType:
	mov eax,[NO_AT_FOUND_JUMPDEST]
pop edi
pop esi
pop ebx
pop edx
pop ecx
mov esp,ebp
pop ebp
	jmp eax
;====================================================================
;DWORD list
;====================================================================
ATINATTable:

rept 100 counter:100 {
     if defined _AT#counter#Init
	dd _AT#counter#Init
     end if
     }

ATINATTable_End:

;====================================================================
ExitINAT:
;====================================================================
	mov eax,[AT_FOUND_JUMPDEST]
mov esi,edi			;save object (address)
pop edi
add esp,4
pop ebx
pop edx
pop ecx
mov esp,ebp
pop ebp
	mov ebp,[esp+18h]	;seems standard amongst ActionTypes
	jmp eax

;====================================================================
UnableToAllocateMem:
;====================================================================
	mov eax,[AT_MEM_ERROR_JUMPDEST]
pop edi
pop esi
pop ebx
pop edx
pop ecx
mov esp,ebp
pop ebp
	mov ebp,[esp+18h]	;seems standard amongst ActionTypes
	jmp eax


