;=================================================================
;VIRTUAL DATA
;=================================================================
;i.e., data defined using 'virtual at' directive


;AT115 temp data

virtual at stack_ext_buffer
	AT115_TempCMessageUseInst	dd	5 dup ?
end virtual


;REC temp data
virtual at stack_ext_buffer
	REC_tempsurface 		DDSURFACEDESC2
end virtual

;PT RT data
virtual at stack_ext_buffer
	PT_tempvalues			PTPOSINFO
end virtual

;HUD RT data
virtual at stack_ext_buffer
	HUD_BGWidth			dd	?
	HUD_BGHeight			dd	?
	HUD_BGColors			dd	?
	HUD_LastDigitWidth		dd	?
	HUD_LastDigitHeight		dd	?
	HUD_LastDigitColors		dd	?
	HUD_BGPosX			dd	?
	HUD_BGPosY			dd	?
	HUD_NextDigitPosX		dd	?
	HUD_NextDigitPosY		dd	?
	HUD_NumberIndexPos100		dd	?
	HUD_NumberIndexPos10		dd	?
	HUD_NumberIndexPos1		dd	?
	HUD_Number2IndexPos100		dd	?
	HUD_Number2IndexPos10		dd	?
	HUD_Number2IndexPos1		dd	?
	HUD_ResDivDefaultResX		dd	?
	HUD_ResDivDefaultResY		dd	?
end virtual

;HUD init data
virtual at stack_ext_buffer
	HUD_INIPath			db	MAX_PATH dup ?
	HUD_CurrentBMPPath		db	MAX_PATH dup ?
	HUD_CurrentBMPPathEnd		dd	?
	HUD_CurrentBMPPathSize		dd	?
	HUD_TempWidthValue		dd	?
	HUD_TempHeightValue		dd	?
	HUD_TempColorsValue		dd	?
	HUD_TempOffsetValue		dd	?
	tempBMPinfo			BITMAPINFOHEADER
end virtual

;ActionType 114 'local' data
virtual at stack_ext_buffer
	AT114_LastError 		dd	?
	AT114_LastError_DWORDParam1	dd	?
	AT114_LastError_DWORDParam2	dd	?
	AT114_LastError_DWORDParam3	dd	?
	AT114_LastError_DWORDParam4	dd	?
	AT114_LastError_DWORDParam5	dd	?
	AT114_MAINGROUPCounter		 dd	 ?
	AT114_SUBGROUPCounter1		 dd	 ?
	AT114_SUBGROUPCounter2		 dd	 ?
	AT114_SUBGROUPIDValue1		 dd	 ?
	AT114_SUBGROUPIDValue2		 dd	 ?
	AT114_TotalProbabilityCount	 dd	 ?
	AT114_NumberOfGroups		 dd	 ?
	AT114_NumberOfInstances 	 dd	 ?
	AT114_NumberOfGroupsXInstances	 dd	 ?
	AT114_TempBufferSize		 dd	 ?
	AT114_SUBGROUPCountCurrent	 dd	 ?
	AT114_LOCATIONGROUPCountCurrent  dd	 ?
	AT114_FlagsPointerCurrent	 dd	 ?
	AT114_ExtraAllocBytes		 dd	 ?	       ;records space used to hold X,Y,Z location value
	AT114_TempBufferBaseFlags	 dd	 ?
	AT114_TempBufferBasePointers	 dd	 ?
	AT114_TempVar			 dd	 ?
	AT114_InstanceSize		 dd	 ?
	AT114_TotalAllocations		 dd	 ?
	AT114_TotalAllocationsSize	 dd	 ?
	AT114_InstanceIDBuffer		 dd	 200 dup ?     ;maximum 200 instances and 200 groups
	AT114_GroupProbabilities	 dd	 200 dup ?
	AT114_MessageBuffer		 db	 300 dup ?
end virtual

virtual at edi
	RayCast_SourcePosX		 dd	 ?
	RayCast_SourcePosY		 dd	 ?
	RayCast_SourcePosZ		 dd	 ?
	RayCast_SourceQuatW		 dd	 ?
	RayCast_SourceQuatX		 dd	 ?
	RayCast_SourceQuatY		 dd	 ?
	RayCast_SourceQuatZ		 dd	 ?
	RayCast_UnknownParam		 dd	 ?
	RayCast_PrivateStrucPointerHold  dd	 ?
	RayCast_TempVectorX		 dd	 ?
	RayCast_TempVectorY		 dd	 ?
	RayCast_TempVectorZ		 dd	 ?
end virtual

virtual at ebp
	THIRDPAIM_FinalDotSize		 dd	 ?
	THIRDPAIM_FinalXValueInt	 dd	 ?
	THIRDPAIM_FinalYValueInt	 dd	 ?
	THIRDPAIM_TempZReciprValue	 dd	 ?
	THIRDPAIM_AIMDOTbmpHandle	 dd	 ?
	THIRDPAIM_CompatibleDCHandle	 dd	 ?
end virtual

virtual at (ebp-(12*4))
    cam1		dd	?
    cam2		dd	?
    cam3		dd	?
    cam4		dd	?
    cam5		dd	?
    cam6		dd	?
    cam7		dd	?
    cam8		dd	?
    cam9		dd	?
    cam10		dd	?
    cam11		dd	?
    cam12		dd	?
end virtual

virtual at (ebp+8)		;requires proper stack frame (ebp pushed and set as esp first)
    param1		dd	?
    param2		dd	?
    param3		dd	?
    param4		dd	?
    param5		dd	?
    param6		dd	?
    param7		dd	?
    param8		dd	?
    param9		dd	?
    param10		dd	?
    param11		dd	?
    param12		dd	?
    param13		dd	?
    param14		dd	?
end virtual



